%define section free
#%define jeditplugdir %{_datadir}/jedit/jars
%define eclipseplugdir %{_datadir}/eclipse/plugins
%define eclipsejalodir %{eclipseplugdir}/de.hunsicker.jalopy.plugin.eclipse

Summary:        Java Source Code Formatter Beautifier Pretty Printer
Name:           jalopy
Version:        1.0
Release:        0.b10.4jpp
Epoch:          0
Group:          Software Development/Quality Assurance
License:        BSD
URL:            http://jalopy.sourceforge.net/
BuildArch:      noarch
Source0:        http://download.sourceforge.net/jalopy/jalopy-1.0b10.src.tar.gz
Source1:        %{name}.jalopy.script
Source2:        %{name}-settings.sh
Source3:        %{name}-settings.desktop
# Converted from main/src/resources/Preferences16.gif
Source4:        %{name}-settings.png
Patch0:         %{name}-eclipse-nover.patch
Patch1:         %{name}-docfix.patch
Patch2:         %{name}-noclasspath.patch
Patch3:         %{name}-xslfix.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Vendor:         JPackage Project
Distribution:   JPackage

BuildRequires:  ant >= 0:1.4, oro, log4j, jdom, junit, gnu.getopt, saxon
#BuildRequires:  jedit >= 0:4.1, jedit-messageview >= 0:0.1.0
BuildRequires:  eclipse-jdt, eclipse-gtk2
BuildRequires:  docbook-xsl-java-saxon, jpackage-utils >= 0:1.5
# This one's named the same on many distros and is located in same place...
BuildRequires:  docbook-style-xsl, /usr/bin/perl
Requires:       log4j, jdom, oro

%description
Jalopy is a source code formatter for the Sun Java programming
language. It layouts any valid Java source code according to some
widely configurable rules; to meet a certain coding style without
putting a formatting burden on individual developers.
With Jalopy you will be able to transform any foreign coding style to
your own preferences, without any browbeating or bloodletting.

%package        console
Group:          Software Development/Quality Assurance
Summary:        Jalopy console plugin
Requires:       %{name} = %{epoch}:%{version}-%{release}, gnu.getopt

%description    console
Jalopy console plugin.

%package     -n ant-%{name}
Group:          Software Development/Quality Assurance
Summary:        Jalopy plugin for Ant
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       ant >= 0:1.4
Obsoletes:      %{name}-ant

%description -n ant-%{name}
Jalopy plugin for Ant.

#%package     -n jedit-%{name}
#Group:          Software Development/Quality Assurance
#Summary:        Jalopy plugin for jEdit
#Requires:       %{name} = %{epoch}:%{version}-%{release}
#Requires:       jedit >= 0:4.1, jedit-messageview >= 0:0.1.0

#%description -n jedit-%{name}
#Jalopy plugin for jEdit.

%package     -n eclipse-%{name}
Group:          Software Development/Quality Assurance
Summary:        Jalopy plugin for Eclipse
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       eclipse-jdt >= 0:2.1.2

%description -n eclipse-%{name}
Jalopy plugin for Eclipse.

%package        manual
Group:          Software Development/Quality Assurance
Summary:        Manual for %{name}

%description    manual
Documentation for %{name}.

%package        javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description    javadoc
Javadoc for %{name}.


%prep
%setup -q -c
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
# Jalopy has a custom antlr, need to use it.
rm -f `find -type f -name "*.jar" -a ! -name "antlr-*"`
# Fix path to DocBook XSL's.  For some reason, a "-DDIR.DOCBOOK.XSL" does
# not seem to work.
perl -pi -e \
  's|^(DIR\.DOCBOOK\.XSL\s*=).*|$1 %{_datadir}/sgml/docbook/xsl-stylesheets|' \
  build/build.properties


%build

# core jars
export CLASSPATH=$(build-classpath ant oro log4j jdom junit gnu.getopt saxon \
docbook-xsl-saxon)

# jedit plugin jars
#export CLASSPATH=$CLASSPATH:$(build-classpath jedit):\
#%{jeditplugdir}/MessageView.jar

# eclipse plugin jars
cd %{eclipseplugdir}
export CLASSPATH=$CLASSPATH:\
$(ls -1d $PWD/org.eclipse.jface_*)/jface.jar:\
$(ls -1d $PWD/org.eclipse.jface.text_*)/jfacetext.jar:\
$(ls -1d $PWD/org.eclipse.text_*)/text.jar:\
$(ls -1d $PWD/org.eclipse.ui.workbench_*)/workbench.jar:\
$(ls -1d $PWD/org.eclipse.swt.gtk_*)/ws/gtk/swt.jar:\
$(ls -1d $PWD/org.eclipse.core.resources_*)/resources.jar:\
$(ls -1d $PWD/org.eclipse.core.runtime_*)/runtime.jar:\
$(ls -1d $PWD/org.eclipse.ui.workbench.texteditor_*)/texteditor.jar:\
$(ls -1d $PWD/org.eclipse.jdt.core_*)/jdtcore.jar
cd -

cd build

# The Xalan that comes with J2SE 1.4 is buggy, and fails to build the docs.
# Since we're using Saxon anyway, let's force it.
export ANT_OPTS=\
"-Djavax.xml.transform.TransformerFactory=\
com.icl.saxon.TransformerFactoryImpl"

# Use the locally installed DocBook 4.2 DTD if available.  The build will
# work without this as well, if a net connection is available (but will be
# slow as hell).  With Ant 1.6, could use the external catalog support of
# xmlcatalog.
DOCBOOK_42_DTD=\
`ls -1 %{_datadir}/sgml/docbook/xml-dtd-4.2*/docbookx.dtd 2>/dev/null || :`

ant \
  -Dbuild.sysclasspath=first \
  -DDIR.DOCBOOK.DTD=$DOCBOOK_42_DTD \
  build-jar-main \
  build-jar-console \
  build-jar-ant \
  build-dist-eclipse \
  build-docu

#  build-jar-jedit \


%install
rm -rf $RPM_BUILD_ROOT

# jar
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p tmp~/build/jars/jalopy-1*.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p tmp~/build/jars/jalopy-ant-*.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-ant-%{version}.jar
cp -p tmp~/build/jars/jalopy-console-*.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-console-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# jedit plugin jars
#mkdir -p $RPM_BUILD_ROOT%{jeditplugdir}
#cp -p tmp~/build/jars/jalopy-jedit-*.jar \
#  $RPM_BUILD_ROOT%{jeditplugdir}/JalopyPlugin.jar
#ln -s %{_javadir}/{jalopy,log4j,oro,jdom}.jar \
#  $RPM_BUILD_ROOT%{jeditplugdir}

# eclipse plugin
mkdir -p $RPM_BUILD_ROOT%{eclipsejalodir}
cp -p tmp~/build/jars/jalopy-eclipse-*.jar \
  $RPM_BUILD_ROOT%{eclipsejalodir}/jalopy-eclipse.jar
cp -p tmp~/eclipse/de.hunsicker.jalopy.plugin.eclipse*/{about.html,plugin.*} \
  $RPM_BUILD_ROOT%{eclipsejalodir}
ln -s %{_javadir}/{jalopy,log4j,oro,jdom}.jar $RPM_BUILD_ROOT%{eclipsejalodir}

# scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/%{name}-settings

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr tmp~/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# combine docs with manual, fix javadoc link
mv tmp~/docs/site/* tmp~/docs/manual/
ln -s %{_javadocdir}/%{name}-%{version} tmp~/docs/manual/api

# freedesktop.org meny entry
install -Dpm 644 %{SOURCE3} \
  $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}-settings.desktop
install -Dpm 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}-settings.png


%clean
rm -rf $RPM_BUILD_ROOT


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{name}-settings
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_datadir}/applications/*%{name}-settings.desktop
%{_datadir}/pixmaps/%{name}-settings.png

%files console
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{name}
%{_javadir}/%{name}-console*

%files -n ant-%{name}
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-ant*

#%files -n jedit-%{name}
#%defattr(0644,root,root,0755)
#%{jeditplugdir}/*

%files -n eclipse-%{name}
%defattr(0644,root,root,0755)
%{eclipsejalodir}

%files manual
%defattr(0644,root,root,0755)
%doc tmp~/docs/manual/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%changelog
* Fri Nov 14 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.b10.4jpp
- Eclipse plugins are now in %%{_datadir}/eclipse.
- Clean up non-versioned javadoc dir symlinking.
- Rename jalopy-preferences to jalopy-settings.
- Add freedesktop.org menu entry for jalopy-settings.
- Fix manual XSL.
- Save .spec in UTF-8, some small cleanups.

* Mon Jun 16 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.b10.3jpp
- Get rid of Class-Paths in manifests, add missing oro.jar to
  base jars in %%{_bindir}/jalopy.

* Sat Mar  1 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.b10.2jpp
- Update for JPackage 1.5.
- Build Eclipse plugin.  (jEdit plugin builds, but doesn't work, deferred)
- Rename ant plugin to ant-jalopy.
- Force use of Saxon when building docs, Xalan from J2SE 1.4 is too buggy.

* Fri Nov 15 2002 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.b10.1jpp
- Update to 1.0b10.

* Wed Nov 13 2002 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.b9.1jpp
- Update to 1.0b9.
- Fix Group tags of manual and javadoc.
- Update preferences shell script main class.

* Sat Oct 12 2002 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.b8.1jpp
- First JPackage release.
